const express = require("express");
const router = express.Router();
const mongoose = require("mongoose");
const Coupon = mongoose.model("Coupon");

router.get("/get-coupon", (req, res) => {
  Coupon.find().then((result) => {
    res.status(200).json({ coupon: result });
    console.log(result);
  });
});

router.post("/set-coupon", (req, res) => {
  const { percentage, coupon_code } = req.body;
  const coupon = new Coupon({
    coupon_code,
    percentage,
  });
  coupon.save().then((result) => {
    res.status(200).json({ message: "Coupon set Successfully" });
  });
});

router.delete("/delete-coupon", (req, res) => {
  Coupon.remove({ _id: req.body.id }).then((result) => {
    res.status(200).json({ message: "Coupon Deleted" });
  });
});

router.put("/update-coupon", (req, res) => {
  Coupon.findByIdAndUpdate(
    req.body._id,
    {
      $set: {
        coupon_code: req.body.coupon_code
      },
    },
    { new: true })
    .then((result) => {
      res.status(200).json({ message: result });
    })
    .catch((err) => {
      console.log(err);
    });
});

module.exports = router;
