const express = require("express");
const couponController = require('../controllers/coupon') ;

const isAuth = require('../middleware/requirelogin') ;
const isAdmin = require('../middleware/isAdmin') ;

const router = express.Router();

router.get("/getAllCoupons",isAuth , isAdmin , couponController.getAllCoupons);

router.post("/addCoupon", isAuth , isAdmin ,couponController.addCoupon);

router.post("/deleteCoupon", isAuth , isAdmin ,couponController.deleteCoupon);

module.exports = router;
